%define conf_path %{_sysconfdir}/%{name}

Name:          gazelle
Version:       1.0.1
Release:       70
Summary:       gazelle is a high performance user-mode stack
License:       MulanPSL-2.0
URL:           https://gitee.com/openeuler/gazelle
Source0:       %{name}-%{version}.tar.gz

BuildRequires: cmake gcc-c++
BuildRequires: lwip >= 2.1.3-75
BuildRequires: dpdk-devel >= 21.11-5
BuildRequires: numactl-devel libpcap-devel libconfig-devel libboundscheck uthash-devel

Requires:      dpdk >= 21.11-5
Requires:      numactl libpcap libconfig libboundscheck

Patch9001:     0001-fix-compile-error-unuse-result.patch
Patch9002:     0002-reduce-copy-in-send.patch
Patch9003:     0003-execute-gazelle_init_sock-before-read-event.patch
Patch9004:     0004-recvmsg-sendmsg-should-use-recvmsg_from_stack-sendms.patch
Patch9005:     0005-fix-LD_PRELOAD.patch
Patch9006:     0006-reduce-replenish-send_idle_ring-rpc-call.patch
Patch9007:     0007-parse_host_addr-should-be-executed-before-parse_dpdk.patch
Patch9008:     0008-fix-gazellectl-l-option-error.patch
Patch9009:     0009-bind-cpu-fail-just-walrm.patch
Patch9010:     0010-mfix-close-not-release-sock.patch
Patch9011:     0011-fix-evetns-err.patch
Patch9012:     0012-fix-dfx-info-show.patch
Patch9013:     0013-balance-acept.patch
Patch9014:     0014-fix-miss-evetn.patch
Patch9015:     0015-fix-too-much-evetns.patch
Patch9016:     0016-fix-dead-loop.patch
Patch9017:     0017-remove-unuse-event.patch
Patch9018:     0018-fix-gazellectl-show.patch
Patch9019:     0019-fix-repeate-msg.patch
Patch9020:     0020-fix-wakeup-typos.patch
Patch9021:     0021-fix-pasre-numacpulist.patch
Patch9022:     0022-fix-get-data-error.patch
Patch9023:     0023-delete-numa-bind-param.patch
Patch9024:     0024-refactor-event.patch
Patch9025:     0025-fix-event-miss.patch
Patch9026:     0026-get-fin-notice-app.patch
Patch9027:     0027-fix-parse-config.patch
Patch9028:     0028-fix-lstack-show-latency.patch
Patch9029:     0029-fix-code-check.patch
Patch9030:     0030-fix-accept-init-sock-faile.patch
Patch9031:     0031-fix-reuse-ip-listen-event-don-t-notice.patch
Patch9032:     0032-modify-readme-to-add-constraint.patch
Patch9033:     0033-fix-accept-check-remain-conn.patch
Patch9034:     0034-fix-wakeup-list-dead-loop.patch
Patch9035:     0035-add-check-for-stack-params.patch
Patch9036:     0036-the-sending-of-sock-last-data-is-triggered-by-lstack.patch
Patch9037:     0037-add-gazellectl-lstack-constraint.patch
Patch9038:     0038-refactor-event.patch
Patch9039:     0039-update-license-lockless-queue.patch
Patch9040:     0040-fix-sock-invalid-address.patch
Patch9041:     0041-exit-lstack-process-after-ltran-instance-logout.patch
Patch9042:     0042-use-atomic-variales-to-count.patch
Patch9043:     0043-re-arrange-the-program-to-invoke-rte_eth_dev_start-b.patch
Patch9044:     0044-delete-redundant-file.patch
Patch9045:     0045-lstack-all-exit-move-to-init.patch
Patch9046:     0046-clean-code-fix-huge-func.patch
Patch9047:     0047-add-kernel-path-in-epoll-funcs.patch
Patch9048:     0048-refactor-kernel-event-poll-epoll.patch
Patch9049:     0049-post-thread_phase1-sem-to-avoid-block-main-thread-wh.patch
Patch9050:     0050-adjust-the-number-of-RX-TX-mbufs-of-each-stack-threa.patch
Patch9051:     0051-modify-README.patch
Patch9052:     0052-bugfix-https-gitee.com-src-openeuler-gazelle-issues-.patch
Patch9053:     0053-update-README.md.patch
Patch9054:     0054-ltran-fix-use-after-free-issue.patch
Patch9055:     0055-refactor-pkt-read-send-performance.patch
Patch9056:     0056-ltran-support-checksum.patch
Patch9057:     0057-add-examples-readme-compile-components-main-file-and.patch
Patch9058:     0058-add-examples-parameter-parsing.patch
Patch9059:     0059-lstack-core-fix-reta_conf-array-size-calculation.patch
Patch9060:     0060-Replace-gettid-with-rte_gettid.patch
Patch9061:     0061-modify-the-code-for-canonical-and-update-the-cmake-b.patch
Patch9062:     0062-enable-secure-compile-and-open-compile-log.patch
Patch9063:     0063-support-epoll-et-trig-mode.patch
Patch9064:     0064-lstack-support-low-power.patch
Patch9065:     0065-add-port-mask-range-check.patch
Patch9066:     0066-release-kni-device.patch
Patch9067:     0067-optimize-check-ltran-exist.patch
Patch9068:     0068-clean-code.patch
Patch9069:     0069-clean-code.patch
Patch9070:     0070-Support-build-gazelle-with-clang.patch
Patch9071:     0071-Allow-dynamic-load-PMDs.patch
Patch9072:     0072-support-epoll-oneshot.patch
Patch9073:     0073-modify-readme-and-clean-code.patch
Patch9074:     0074-ltran-support-muti-proc-with-same-ip.patch
Patch9075:     0075-fix-rpc-msg-out-of-bound.patch
Patch9076:     0076-fix-traversal-array-use-NULL-pointer.patch
Patch9077:     0077-same-stack-thread-don-t-repeate-send-msg.patch
Patch9078:     0078-fix-memcpy-out-bounds.patch
Patch9079:     0079-fix-miss-send-rpc-msg-err.patch
Patch9080:     0080-fix-proc-can-not-exit-due-to-lack-of-mem-startup-fai.patch
Patch9081:     0081-read-data-with-err-event.patch
Patch9082:     0082-del-gazelle-ring-cons.tail-atomic-protect.patch
Patch9083:     0083-fix-send-return-vale.patch
Patch9084:     0084-add-examples.patch
Patch9085:     0085-expand-thread-rpc-msg-pool-size.patch
Patch9086:     0086-fix-fd-leak.patch
Patch9087:     0087-fix-del-conn-use-after-free.patch
Patch9088:     0088-init-g_gazelle_errno-before-use.patch
Patch9089:     0089-code-format-specification.patch
Patch9090:     0090-fix-gazelle-kernel-event-thread-affinity-same-with-s.patch
Patch9091:     0091-have_corelist_arg.patch
Patch9092:     0092-ltran-update-list.patch
Patch9093:     0093-remove-get_reg_ring_free_count.patch
Patch9094:     0094-add-errorno-EISCONN.patch
Patch9095:     0095-fix-sendmsg-data-write-wrong.patch
Patch9096:     0096-lstack-restore-pci-bus-after-init.patch
Patch9097:     0097-fix-malloc-rpc-msg-fail.patch
Patch9098:     0098-support-dpdk-dynamic-memory.patch
Patch9099:     0099-fix-lwip_send-fail-free-pbuf-miss-data.patch
Patch9100:     0100-merger-wakeup.patch
Patch9101:     0101-conenct-support-multi-queues.patch
Patch9102:     0102-merge-sendmsg-write.patch
Patch9103:     0103-add-thread-select-path.patch
Patch9104:     0104-support-conf-control-app-bind-numa.patch
Patch9105:     0105-fix-epoll_wait-cover-kernel-event.patch
Patch9106:     0106-fix-read-stack-data-return-0-when-no-data.patch
Patch9107:     0107-fix-stack-wakeup-node-del.patch
Patch9108:     0108-avoid-useless-stack-check-wakeup-event.patch
Patch9109:     0109-fix-mesg-loss.patch
Patch9110:     0110-add-accept4-and-epoll_create1.patch
Patch9111:     0111-refactor-event-notice.patch
Patch9112:     0112-add-writev-and-readv.patch
Patch9113:     0113-optimized-some-function-in-lstack.patch
Patch9114:     0114-fix-gazellectl-stats-err-when-donot-bind-numa.patch
Patch9115:     0115-add-usleep-when-write_ring-is-busy.patch
Patch9116:     0116-optimize-variable-access.patch
Patch9117:     0117-add-gro.patch
Patch9118:     0118-expand-nic-rx-desc-size.patch
Patch9119:     0119-add-kni-local-support-in-lstack.patch
Patch9120:     0120-resolve-the-conflict-between-the-eth_dev_ops-variabl.patch
Patch9121:     0121-add-pdump-support-in-lstack.patch
Patch9122:     0122-fix-uninit-stack-port_id-when-use-mutil-NIC.patch
Patch9123:     0123-fix-memleak-in-dpdk_ethdev_init-unlikely-path.patch
Patch9124:     0124-fix-epoll_wait-return-when-timeout-is-0.patch
Patch9125:     0125-fix-gazelle-pdump-init-fail-with-dpdk-21.11.patch
Patch9126:     0126-fix-add-outdated-event.patch
Patch9127:     0127-revert-write-usleep.patch
Patch9128:     0128-reduce-thread-variable-access.patch
Patch9129:     0129-add-readv-and-readv-kernel.patch
Patch9130:     0130-add-unlock-before-after.patch
Patch9131:     0131-add-mutil-NIC-support-in-gazelle.patch
Patch9132:     0132-remove-filename_check-in-gazellectl-to-fix-build-err.patch
Patch9133:     0133-cancel-kernel-sock-epoll-ctl-when-lwip-sock-connect.patch
Patch9134:     0134-modify-readv-and-writev-first-buf-is-null.patch
Patch9135:     0135-fix-pdump-and-mutil-NIC-init-fail.patch
Patch9136:     0136-modify-duplicate-code.patch
Patch9137:     0137-merge-lstack-rx-tx-mbuf-pool.patch
Patch9138:     0138-avoid-send-stop-when-mbuf-pool-empty.patch
Patch9139:     0139-fix-pcb-snd_buf-flip.patch
Patch9140:     0140-fix-lwip-send-return-0-add-err-event.patch
Patch9141:     0141-fix-data-flow-error-when-use-NIC-in-kernel.patch
Patch9142:     0142-fix-write-event-error.patch
Patch9143:     0143-add-malloc-init-zero.patch
Patch9144:     0144-modify-event-error.patch
Patch9145:     0145-add-unix_prefix-in-gazellectl.patch
Patch9146:     0146-fix-epoll_wait-report-event0.patch
Patch9147:     0147-add-TSO.patch
Patch9148:     0148-optimize-app-thread-write-buff-block.patch
Patch9149:     0149-expand-rxtx-mbuf-pool.patch
Patch9150:     0150-add-pdump-support-in-ltran.patch
Patch9151:     0151-dfx-gazellectl-add-pcb-wins-info.patch
Patch9152:     0152-fix-genarate-out-event-untimely.patch
Patch9153:     0153-rxtx-mbuf-pool-size-config-by-conf.patch
Patch9154:     0154-fix-kernel-event-thread-bind-numa-failed.patch
Patch9155:     0155-stack-thread-parms-config-by-conf.patch
Patch9156:     0156-ltran-rxtx-mbuf-pool-size-config-by-conf.patch
Patch9157:     0157-move-select_thread_path-after-posix_api_init.patch
Patch9158:     0158-add-RXTX_NB_MBUF_MAX-to-limit-mbuf_pool_size-to-its-.patch
Patch9159:     0159-stack-thread-params-default-val.patch
Patch9160:     0160-optimite-net-type.patch
Patch9161:     0161-app-bind-numa-when-epoll-poll-create.patch
Patch9162:     0162-remove-mbuf-reserve-in-mbuf-alloc.patch
Patch9163:     0163-pkts-bulk-send-to-nic.patch
Patch9164:     0164-rpc-dont-send.patch
Patch9165:     0165-recv-pbuf-free-timely.patch
Patch9166:     0166-optimite-send-pkts-dul-index.patch
Patch9167:     0167-expand-data-recv-buff.patch
Patch9168:     0168-dfx-add-mempool-count-info.patch
Patch9169:     0169--write-support-without-epoll-poll.patch
Patch9170:     0170-add-rcv-nxt-dfx-info.patch
Patch9171:     0171-mbuf-private-data-size-align-cache-line.patch
Patch9172:     0172-fix-send-pkts-bluk-err.patch
Patch9173:     0173-free-recv-pkts-bluks.patch
Patch9174:     0174-fix-lstack-Makefile-warning.patch
Patch9175:     0175-fix-null-pointer-deref-in-stack_broadcast_close.patch
Patch9176:     0176-pbuf-align-cache-line.patch
Patch9177:     0177-support-set-main-thread-affinity.patch
Patch9178:     0178-reduce-epoll-wakeup.patch
Patch9179:     0179-revert-expand-recv-data-buff.patch
Patch9180:     0180-add-the-suggestion-of-using-the-u-parameter-when-the.patch
Patch9181:     0181-move-control_client_thread-creation-after-control_in.patch
Patch9182:     0182-add-ret-check-in-pthread_create-and-fix-example-bug.patch
Patch9183:     0183-add-log-message-when-wait-for-connecting-to-ltran.patch
Patch9184:     0184-add-gazelle-fuzz.patch
Patch9185:     0185-add-unitest.patch
Patch9186:     0186-add-gazelle-setup-tools.patch
Patch9187:     0187-test-readv-writev-epoll_create1-accept4.patch
Patch9188:     0188-add-fucntest.patch
Patch9189:     0189-fix-coredump-in-example-server-mum-mode.patch
Patch9190:     0190-bring-up-kni-when-init.patch
Patch9191:     0191-change-mbuf_pool_size-in-lstack.conf-to-tcp_conn_cou.patch
Patch9192:     0192-fix-build-error-in-lstack.patch
Patch9193:     0193-check-and-fix-wakeup_list-when-null-appears.patch
Patch9194:     0194-eneble-TSO-and-fix-TSO-mbuf-pktlen-error.patch
Patch9195:     0195-adapt-unsupport-sock-optname.patch
Patch9196:     0196-reduce-duplicate-code-in-lstack_cfg.c.patch
Patch9197:     0197-fix-private-data-offset-error.patch
Patch9198:     0198-fix-do_close-core-dump.patch
Patch9199:     0199-remove-rxtx-driver-cache.patch
Patch9200:     0200-send-ring-size-is-configure.patch
Patch9201:     0201-send-should-return-1-errno-EAGAIN-when-ring-full.patch
Patch9202:     0202-when-send-ring-full-whether-dynamic-alloc-mbuf-is-co.patch
Patch9203:     0203-add-pbuf-lock-when-aggregate-pbuf.patch
Patch9204:     0204-supprot-multi-process.patch
Patch9205:     0205-add-gazellectl-x-to-show-nic-stats.patch
Patch9206:     0206-add-same-node-ring-for-inter-proces-communication.patch
Patch9207:     0207-fix-send-reset-by-peer-when-not-sleep-after-connect.patch
Patch9208:     0208-add-tuple-filter-in-conf-to-diff-rss-rule-and-tuple-.patch
Patch9209:     0210-disable-tso-without-ipv4-checksum.patch
Patch9210:     0210-support-tuple-rule-add-delete.patch
Patch9211:     0211-refactor-mbuf-private-data.patch
Patch9212:     0212-fix-kernel-scoket-select-path-error.patch
Patch9213:     0213-discard-wakeup_num-parameter.patch
Patch9214:     0214-fix-parse-args-error.patch
Patch9215:     0215-gazelle-send-recv-thread-bind-numa.patch
Patch9216:     0216-waiting-when-primary-process-not-start-already.patch
Patch9217:     0217-sepeate_string_to-array-add-error-args-handle.patch
Patch9218:     0218-do-not-transfer-broadcast-arp-pkts-to-other-process.patch
Patch9219:     0219-revert-select_thread_path-and-optimize-app-thread-wh.patch
Patch9220:     0220-check-primary-process-idx-and-secondary-lstack-num.patch
Patch9221:     0221-optimite-select_path-and-pbuf_take.patch
Patch9222:     0222-fix-build-err-on-select_path.patch
Patch9223:     0223-set-kni_switch-valid-only-in-primary-process.patch
Patch9224:     0224-optimize-do_close.patch
Patch9225:     0225-add-socket-check-before-write-it.patch
Patch9226:     0226-update-lstack.Makefile.patch
Patch9227:     0227-fix-config-flow-rule-race.patch
Patch9228:     0228-fix-build-err-with-dpdk-21.11.patch
Patch9229:     0229-fix-gazellectl-x-error-when-multiplt-user-nic-config.patch
Patch9230:     0230-fix-client-connect-number-unbalance-on-lstack.patch
Patch9231:     0231-kni-down-not-stop-nic.patch
Patch9232:     0232-fix-rpc-msg-alloc-failed.patch
Patch9233:     0233-add-parentheses-to-fix-build-error.patch
Patch9234:     0234-fix-bond_ports-parse-error.patch
Patch9235:     0235-dfx-set-g_unix_fd-to-1-after-abnormal-close-fd-to-av.patch
Patch9236:     0236-dfx-security-function-failed-return-error-directly.patch
Patch9237:     0237-add-bond4-suport.patch
Patch9238:     0238-clean-code.patch
Patch9239:     0239-add-udp-multicast-support-in-gazelle.patch
Patch9240:     0240-modify-huge-dir-dir-name.patch
Patch9241:     0241-drop-netbuf-in-read_lwip_data-to-fix-mem-overflow.patch
Patch9242:     0242-send-recv-thread-bind-numa-only-app_bind_numa-set-to.patch
Patch9243:     0243-fix-change-low-power-mod-invalid.patch
Patch9244:     0244-add-exception-handling-for-is_dst_ip_localhost.patch
Patch9245:     0245-fix-gazellectl-block-before-lstack-registration-is-c.patch
Patch9246:     0246-fix-udp-send-recv-in-muliple-queue.patch
Patch9247:     0247-set-sock-when-select-path-is-PATH_UNKNOW.patch
Patch9248:     0248-rpc-pool-use-dpdk-mempool-replace-array.patch
Patch9249:     0249-fix-t_params-use-after-free-in-kernel-event-thread.patch
Patch9250:     0250-adapt-to-dpdk-19.11-and-dpdk-21.11.patch
Patch9251:     0251-change-send_ring_size-32-in-lstack-conf.patch
Patch9252:     0252-add-use_sockmap-in-cfg-to-distinguish-whether-to-use.patch
Patch9253:     0253-add-multicast-enable-in-dpdk_ethdev_init.patch
Patch9254:     0254-fix-null-pointer-of-sock-in-udp_recvfrom.patch
Patch9255:     0255-skip-gro-when-tcp-ip-checksum-offloads-disable.patch
Patch9256:     0256-lstack-cfg-add-app_exclude_cpus.patch
Patch9257:     0257-enable-UDP-CKSUM-in-gazelle.patch
Patch9258:     0258-fix-core-dump-when-slave-mac-failed.patch
Patch9259:     0259-check-return-value-of-hugepage_init-to-avoid-coredum.patch
Patch9260:     0260-add-udp_enable-to-turn-off-udp-in-need.patch

%description
%{name} is a high performance user-mode stack.

ExclusiveArch: x86_64 aarch64

%prep
%autosetup -n %{name}-%{version} -p1

%build
#export DPDK_VERSION_1911=1
cd %{_builddir}/%{name}-%{version}
# Add compile option, ignore map address check. Scenarios: asan test
%if 0%{?gazelle_map_addr_nocheck}
    sed -i 's/-pthread/-pthread -D gazelle_map_addr_nocheck/' %{_builddir}/%{name}-%{version}/src/ltran/CMakeLists.txt
%endif
sh build/build.sh

%install
install -dpm 0755 %{buildroot}/%{_bindir}
install -dpm 0755 %{buildroot}/%{_prefix}/lib64
install -dpm 0750 %{buildroot}/%{conf_path}

install -Dpm 0500 %{_builddir}/%{name}-%{version}/src/lstack/liblstack.*     %{buildroot}/%{_libdir}/
install -Dpm 0640 %{_builddir}/%{name}-%{version}/src/lstack/lstack.Makefile %{buildroot}/%{conf_path}/
install -Dpm 0640 %{_builddir}/%{name}-%{version}/src/lstack/lstack.conf     %{buildroot}/%{conf_path}/

install -Dpm 0500 %{_builddir}/%{name}-%{version}/src/ltran/gazellectl       %{buildroot}/%{_bindir}/
install -Dpm 0500 %{_builddir}/%{name}-%{version}/src/ltran/ltran            %{buildroot}/%{_bindir}/
install -Dpm 0640 %{_builddir}/%{name}-%{version}/src/ltran/ltran.conf       %{buildroot}/%{conf_path}/

%files
%defattr(-,root,root)
%dir %{conf_path}
%{_bindir}/*
%{_libdir}/liblstack.*
%{conf_path}/lstack.Makefile
%config(noreplace) %{conf_path}/lstack.conf
%config(noreplace) %{conf_path}/ltran.conf

%changelog
* Fri Jun 30 2023 jiangheng12 <jiangheng14@huawei.com> - 1.0.1-70
- add build requires constraints on lwip version

* Tue Jun 27 2023 jiangheng12 <jiangheng14@huawei.com> - 1.0.1-69
- add udp_enable to turn off udp in need

* Wed Jun 21 2023 jiangheng12 <jiangheng14@huawei.com> - 1.0.1-68
- check return value of hugepage_init to avoid coredump when hugepage memory is insufficient
- fix core dump when slave mac failed

* Sun Jun 25 2023 kircher <majun65@huawei.com> - 1.0.1-67
- enable UDP CKSUM in gazelle
- lstack: cfg add app_exclude_cpus
- skip gro when tcp/ip checksum offloads disable
- fix null pointer of sock in udp_recvfrom

* Mon Jun 19 2023 jiangheng12 <jiangheng14@huawei.com> - 1.0.1-66
- add multicast enable in dpdk_ethdev_init
- add use_sockmap in cfg to distinguish whether to use dpdk ring communication between processes

* Mon Jun 19 2023 jiangheng12 <jiangheng14@huawei.com> - 1.0.1-65
- remove obsolete args num_wakeup in doc

* Thu Jun 15 2023 jiangheng12 <jiangheng14@huawei.com> - 1.0.1-64
- change send_ring_size 32 in lstack conf
- adapt to dpdk-19.11 and dpdk-21.11
- fix t_params use after free in kernel event thread
- rpc pool use dpdk mempool replace array

* Wed Jun 14 2023 jiangheng12 <jiangheng14@huawei.com> - 1.0.1-63
- set sock when select path is PATH_UNKNOW

* Wed Jun 14 2023 jiangheng12 <jiangheng14@huawei.com> - 1.0.1-62
- fix udp send/recv in muliple queue
- fix gazellectl block before lstack registration is complete
- add exception handling for is_dst_ip_localhost
- fix change low power mod invalid
- send/recv thread bind numa only app_bind_numa set to 1

* Tue Jun 6 2023 jiangheng <jiangheng14@huawei.com> - 1.0.1-61
- revert cleancode series patches

* Fri Jun 2 2023 LemmyHuang <huangliming5@huawei.com> - 1.0.1-60
- fix socket init and clean
- fix coredump caused by lwip_get_socket_nouse

* Mon May 29 2023 LemmyHuang <huangliming5@huawei.com> - 1.0.1-59
- drop netbuf in read_lwip_data to fix mem overflow
- cleancode: refactor memp
- cleancode: refactor sys_now and lwip_ioctl
- cleancode: refactor gazelle_hlist.h
- cleancode: refactor gazelle_list.h
- cleancode: refactor gazelle_posix_api.h
- cleancode: refactor lwipsock.h
- cleancode: rename gazelle files in lwip
- cleancode: improving makefile readability

* Sat May 20 2023 jiangheng <jiangheng14@huawei.com> - 1.0.1-58
- modify hugepage directory name

* Tue May 16 2023 kircher <majun65@huawei.com> - 1.0.1-57
- add udp multicast support in gazelle
- clean code
- add bond4 suport
- dfx: security function failed, return error directly
- dfx: set g_unix_fd to -1 after abnormal close fd to avoid double close
- fix bond_ports parse error fix socket_mem parse error when the value exceeds 65536 exit if create_rxtx_pktmbuf failed build.sh build failed return 1 clean code
- add parentheses to fix build error
- fix rpc msg alloc failed fix process_numa args error coredump fix sock->conn not free when fd is kernel mode
- kni down not stop nic
- fix client connect number unbalance on lstack
- fix gazellectl -x error when multiplt user nic config

* Sat May 13 2023 jiangheng12 <jiangheng14@huawei.com> - 1.0.1-56
- fix build err with dpdk-21.11
- fix config flow rule race
- update lstack.Makefile
- add socket check before write it
- optimize do_close
- set kni_switch valid only in primary process
- fix build err on select_path
- optimite select_path and pbuf_take
- check primary process idx and secondary lstack num
- revert select_thread_path and optimize app thread when sendmsg
- do not transfer broadcast arp pkts to other process

* Thu Apr 20 2023 sunsuwan <sunsuwan3@huawei.com> - 1.0.1-55
- sepeate_string_to array add error args handle

* Thu Apr 20 2023 wu-changsheng <wuchangsheng2@huawei.com> - 1.0.1-54
- waiting when primary process not start already
- gazelle send/recv thread bind numa

* Tue Mar 21 2023 jiangheng12 <jiangheng14@huawei.com> - 1.0.1-53
- fix parse args error
- discard wakeup_num parameter
- fix kernel scoket select path error

* Sat Mar 18 2023 jiangheng<jiangheng14@huawei.com> - 1.0.1-52
- add pbuf lock when aggregate pbuf
- support multi process
- add gazellectl -x -a args
- add same node ring for iner-process communication
- fix send reset by peer when not sleep after connect
- add tuple filter in conf to diff rss rule adn tuple filter rule
- support tuple rule add/delete
- disable tso without ipv4 checksum
- refactor mbuf private data

* Sat Mar 11 2023 kircher <majun65@huawei.com> - 1.0.1-51
- when send ring full whether dynamic alloc mbuf is configurable reduce cpu usage when send ring full
- send should return -1, errno EAGAIN when ring full
- send ring size is configure
- remove rxtx driver cache
- fix do_close core dump
- fix private data offset error

* Mon Feb 27 2023 wu-changsheng <wuchangsheng2@huawei.com> - 1.0.1-50
- reduce duplicate code in lstack_cfg.c
- adapt unsupport sock optname

* Wed Feb 22 2023 kircher <majun65@huawei.com> - 1.0.1-49
- eneble TSO and fix TSO mbuf pktlen error
- check and fix wakeup_list when null appears

* Mon Feb 13 2023 net <jiangheng14@huawei.com> - 1.0.1-48
- change mbuf_pool_size in lstack.conf to tcp_conn_count * mbuf_count_per_conn
- bring up kni when init
- fix coredump in example server mum mode
- add fucntest
- test readv writev epoll_create1 accept4

* Mon Feb 6 2023 jiangheng12 <jiangheng14@huawei.com> - 1.0.1-47
- add gazelle setup tools
- add unitest

* Tue Jan 31 2023 kircher <majun65@huawei.com> - 1.0.1-46
- add gazelle fuzz
- add log message when wait for connecting to ltran

* Mon Jan 16 2023 kircher <majun65@huawei.com> - 1.0.1-45
- add ret check in pthread_create and fix example bug
- move control_client_thread creation after control_in and dpdk_skip_nic_init

* Fri Jan 6 2023 kircher <majun65@huawei.com> - 1.0.1-44
- add the suggestion of using the -u parameter when the connection to unix socket fails

* Fri Dec 30 2022 wuchangsheng <wuchangsheng2@huawei.com> - 1.0.1-43
- revert expand recv data buff

* Wed Dec 28 2022 wuchangsheng <wuchangsheng2@huawei.com> - 1.0.1-42
- pbuf cacheline align
  support main thread affinity
  reduce epoll wakeup

* Fri Dec 23 2022 kircher <majun65@huawei.com> - 1.0.1-41
- fix null pointer deref in stack_broadcast_close
- fix lstack Makefile warning

* Thu Dec 22 2022 wuchangsheng <wuchangsheng2@huawei.com> - 1.0.1-40
- add dfx rcv_nxt info
  mbuf private cache line align
  send pkts index bug fix
  free recv pkts in main loop

* Wed Dec 21 2022 wuchangsheng <wuchangsheng2@huawei.com> - 1.0.1-39
- add mempool dfx info
  write support without epoll/poll

* Tue Dec 20 2022 wuchangsheng <wuchangsheng2@huawei.com> - 1.0.1-38
- optimite recv data buff and send pkts index

* Sun Dec 18 2022 wuchangsheng <wuchangsheng2@huawei.com> - 1.0.1-37
- pkts-bulk-send-to-nic and rpc-dont-send

* Sat Dec 17 2022 jiangheng <jiangheng14@huawei.com> - 1.0.1-36
- remove mbuf reserve in mbuf alloc

* Sat Dec 17 2022 jiangheng <jiangheng14@huawei.com> - 1.0.1-35
- optimite net type
  app bind numa when epoll/poll create
  stack thread params set dafult value

* Sat Dec 17 2022 kircher <majun65@huawei.com> - 1.0.1-34
- add RXTX_NB_MBUF_MAX to limit mbuf_pool_size to its range

* Fri Dec 16 2022 kircher <majun65@huawei.com> - 1.0.1-33
- move select_thread_path after posix_api_init

* Thu Dec 15 2022 jiangheng <jiangheng14@huawei.com> - 1.0.1-32
- ltran rxtx mbuf pool size config by conf

* Thu Dec 15 2022 wuchangsheng <wuchangsheng2@huawei.com> - 1.0.1-31
- stack thread params config by lstack.conf

* Wed Dec 14 2022 jiangheng <jiangheng14@huawei.com> - 1.0.1-30
- fix kernel event thread bind nuam failed

* Tue Dec 13 2022 wuchangsheng <wuchangsheng2@huawei.com> - 1.0.1-29
- dfx add pcb windows info
  rxtx mbuf pool size config by conf

* Mon Dec 12 2022 kircher <majun65@huawei.com> - 1.0.1-28
- add pdump support in ltran

* Sat Dec 3 2022 wuchangsheng <wuchangsheng2@huawei.com> - 1.0.1-27
- optimize app thread write buff block

* Fri Dec 2 2022 wuchangsheng <wuchangsheng2@huawei.com> - 1.0.1-26
- fix epoll_wait report events 0

* Thu Dec 1 UTC compile_success <980965867@qq.com> - 1.0.1-25
- add malloc init zero
- modify EPOLLOUT event is overwritten.

* Sat Nov 26 UTC compile_success <980965867@qq.com> - 1.0.1-24
- fix write event error

* Wed Nov 16 2022 kircher <majun65@huawei.com> - 1.0.1-23
- modify duplicate code
- fix data flow error when use NIC in kernel
- fix lwip send return 0 add err event
- fix pcb snd_buf flip
- avoid send stop when mbuf pool empty
- merge lstack rx tx mbuf pool

* Tue Nov 15 2022 kircher <majun65@huawei.com> - 1.0.1-22
- fix pdump and mutil NIC init fail

* Mon Nov 14 2022 wuchangsheng <wuchangsheng2@huawei.com> - 1.0.1-21
- support muti-nic
  fix some bugs

* Tue Nov 8 2022 kircher <majun65@huawei.com> - 1.0.1-20
- add pdump support in lstack

* Sat Nov 07 2022 wuchangsheng <wuchangsheng2@huawei.com> - 1.0.1-19
- resolve the conflict between the eth_dev_ops variable and the dpdk-19.11

* Sat Nov 05 2022 kircher <majun65@huawei.com> - 1.0.1-18
- Add kni local support in lstack

* Fri Nov 04 2022 wuchangsheng <wuchangsheng2@huawei.com> - 1.0.1-17
- Optimize ceph client performance

* Sat Oct 08 2022 wuchangsheng <wuchangsheng2@huawei.com> - 1.0.1-16
- refactor event
  addapt for ceph client

* Mon Sep 05 2022 wuchangsheng <wuchangsheng2@huawei.com> - 1.0.1-15
- expand rpc msg pool size

* Mon Sep 05 2022 wuchangsheng <wuchangsheng2@huawei.com> - 1.0.1-14
- backport bugfix and doc

* Mon Aug 08 2022 fushanqing <fushanqing@kylinos.cn> - 1.0.1-13
- Unified license name specification

* Tue Jul 26 2022 wuchangsheng <wuchangsheng2@huawei.com> - 1.0.1-12
- support epoll oneshot 

* Tue Jul 19 2022 xiusailong <xiusailong@huawei.com> - 1.0.1-11
- reconstruct packet sending and receiving to improve performance 

* Thu Jul 7 2022 jiangheng <jiangheng14@huawei.com> - 1.0.1-10
- Type:bugfix
- CVE:
- SUG:NA
- DESC:update readme
       fix some bugs
       refactor pkt read send to improve performance
       refactoe kernle event to improve performanc 

* Fri May 27 2022 xiusailong <xiusailong@huawei.com> - 1.0.1-9
- update license lockless queue

* Fri May 20 2022 xiusailong <xiusailong@huawei.com> - 1.0.1-8
- update README.md

* Thu Mar 31 2022 jiangheng <jiangheng12@huawei.com> - 1.0.1-7
- Type:bugfix
- CVE:
- SUG:NA
- DESC:add gazelle.yaml

* Tue Mar 29 2022 jiangheng <jiangheng12@huawei.com> - 1.0.1-6
- refactor event
- add gazellectl lstack constraint

* Fri Mar 18 2022 jiangheng <jiangheng12@huawei.com> - 1.0.1-5
- limit lwip_alloc_pbuf size to TCP_MSS
- sending of sock last data is triggered by lstack iteself 

* Thu Mar 17 2022 jiangheng <jiangheng12@huawei.com> - 1.0.1-4
- fix repeatede stack restart coredump

* Wed Mar 16 2022 jiangheng <jiangheng12@huawei.com> - 1.0.1-3
- fix gazelle test issue

* Mon Mar 7 2022 wu-changsheng <wuchangsheng2@huawei.com> - 1.0.1-2
- reduce copy in send

* Thu Mar 3 2022 wu-changsheng <wuchangsheng2@huawei.com> - 1.0.1-1
- support mysql with two mode:ltran+lstack and lstack.

* Thu Feb 24 2022 wu-changsheng <wuchangsheng2@huawei.com> - 1.0.0-1
- release initial version
